#### test/ebdic-koujien.rb -- unit test for ebdic module, using KOUJIEN

require 'runit/testcase'

$stdout.sync = true

class EBDicKoujienTest <RUNIT::TestCase
  def setup
    @ebdic = EBDic.new("/opt/epwing/koujien", "KOUJIEN")
  end

  def test_search_failure
    assert(@ebdic.search("ۤ").empty?)
    assert(@ebdic.search("\001\001").empty?)
  end

  def test_search_success
    assert_equal(";",
		 @ebdic.search("").join(";"))
    assert_equal(";oui;ե",
		 @ebdic.search("").join(";"))
    assert_equal("衼å;Europa;ݥȥ;;",
		 @ebdic.search("衼ä").join(";"))
    assert_equal("Ǥ;;;;;;;;ޥ;maquis;ե",
		 @ebdic.search("ޤ").join(";"))
    assert_equal("Ρ٥",
		 @ebdic.search("Ρ٤뤷礦").join(";"))
    assert_equal("Żҥ᡼",
		 @ebdic.search("Ǥ󤷤᡼").join(";"))
    assert_equal("ų̥ȥ󥸥",
		 @ebdic.search("Ǥ󤫤Ȥ󤸤").join(";"))
    assert_equal("Żҥԥ",
		 @ebdic.search("Ǥ󤷤Ԥ󤭤礦ᤤ").join(";"))
    assert_equal("ȥޥ;",
		 @ebdic.search("Ȥޤ").join(";"))
    assert_equal("United States of America",
		 @ebdic.search("ʤƤäɤơĤ֤꤫").join(";"))
    assert_equal("亮ȥ;Washington;亮ȥ;Washington;",
		 @ebdic.search("路Ȥ").join(";"))
    assert_equal("ӥߥ;Vitamin;ɥ;vitamine;ꥹ",
		 @ebdic.search("Ӥߤ").join(";"))
  end

  def tear_down
  end
end

if __FILE__ == $0
  load 'skkserv/ebdic.rb'

  require 'runit/cui/testrunner'
  RUNIT::CUI::TestRunner.run(EBDicKoujienTest.suite)
end

# test/ebdic-koujien.rb ends here
